/*
	Реализация спецификаций CLDC версии 1.1 (JSR-139), MIDP версии 2.1 (JSR-118)
	и других спецификаций для функционирования компактных приложений на языке
	Java (мидлетов) в среде программного обеспечения Малик Эмулятор.

	Copyright © 2016, 2019 Малик Разработчик

	Это свободная программа: вы можете перераспространять ее и/или изменять
	ее на условиях Меньшей Стандартной общественной лицензии GNU в том виде,
	в каком она была опубликована Фондом свободного программного обеспечения;
	либо версии 3 лицензии, либо (по вашему выбору) любой более поздней версии.

	Эта программа распространяется в надежде, что она будет полезной,
	но БЕЗО ВСЯКИХ ГАРАНТИЙ; даже без неявной гарантии ТОВАРНОГО ВИДА
	или ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Подробнее см. в Меньшей Стандартной
	общественной лицензии GNU.

	Вы должны были получить копию Меньшей Стандартной общественной лицензии GNU
	вместе с этой программой. Если это не так, см.
	<https://www.gnu.org/licenses/>.
*/


package java.io;

public interface DataOutput
{
	public void write(int src)
			throws IOException;

	public void write(byte[] src)
			throws IOException;

	public void write(byte[] src, int offset, int length)
			throws IOException;

	public void writeBoolean(boolean src)
			throws IOException;

	public void writeChar(int src)
			throws IOException;

	public void writeFloat(float src)
			throws IOException;

	public void writeDouble(double src)
			throws IOException;

	public void writeByte(int src)
			throws IOException;

	public void writeShort(int src)
			throws IOException;

	public void writeInt(int src)
			throws IOException;

	public void writeLong(long src)
			throws IOException;

	public void writeUTF(String src)
			throws IOException;

	public void writeChars(String src)
			throws IOException;
}
