﻿/*
	Реализация спецификаций CLDC версии 1.1 (JSR-139), MIDP версии 2.1 (JSR-118)
	и других спецификаций для функционирования компактных приложений на языке
	Java (мидлетов) в среде программного обеспечения Малик Эмулятор.

	Copyright © 2016, 2019 Малик Разработчик

	Это свободная программа: вы можете перераспространять ее и/или изменять
	ее на условиях Меньшей Стандартной общественной лицензии GNU в том виде,
	в каком она была опубликована Фондом свободного программного обеспечения;
	либо версии 3 лицензии, либо (по вашему выбору) любой более поздней версии.

	Эта программа распространяется в надежде, что она будет полезной,
	но БЕЗО ВСЯКИХ ГАРАНТИЙ; даже без неявной гарантии ТОВАРНОГО ВИДА
	или ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Подробнее см. в Меньшей Стандартной
	общественной лицензии GNU.

	Вы должны были получить копию Меньшей Стандартной общественной лицензии GNU
	вместе с этой программой. Если это не так, см.
	<https://www.gnu.org/licenses/>.
*/


package java.io;

public abstract class OutputStream extends Object
{
	public OutputStream()
	{
	}

	public abstract void write(int src)
			throws IOException;

	public void close()
			throws IOException
	{
	}

	public void flush()
			throws IOException
	{
	}

	public void write(byte[] src)
			throws IOException
	{
		int length;
		int i;
		if(src == null)
		{
			throw new NullPointerException("OutputStream.write: " +
					"параметр src равен нулевой ссылке.");
		}
		for(length = src.length, i = 0; i < length; i++)
		{
			write(src[i]);
		}
	}

	public void write(byte[] src, int offset, int length)
			throws IOException
	{
		int lim;
		int len;
		int i;
		if(src == null)
		{
			throw new NullPointerException("OutputStream.write: " +
					"параметр src равен нулевой ссылке.");
		}
		if((lim = offset + length) > (len = src.length) ||
				lim < offset || offset > len || offset < 0)
		{
			throw new ArrayIndexOutOfBoundsException("OutputStream.write: " +
					"индекс выходит из диапазона.");
		}
		for(i = 0; i < length; i++)
		{
			write(src[offset++]);
		}
	}
}
