/*
	Реализация спецификаций CLDC версии 1.1 (JSR-139), MIDP версии 2.1 (JSR-118)
	и других спецификаций для функционирования компактных приложений на языке
	Java (мидлетов) в среде программного обеспечения Малик Эмулятор.

	Copyright © 2016, 2019 Малик Разработчик

	Это свободная программа: вы можете перераспространять ее и/или изменять
	ее на условиях Меньшей Стандартной общественной лицензии GNU в том виде,
	в каком она была опубликована Фондом свободного программного обеспечения;
	либо версии 3 лицензии, либо (по вашему выбору) любой более поздней версии.

	Эта программа распространяется в надежде, что она будет полезной,
	но БЕЗО ВСЯКИХ ГАРАНТИЙ; даже без неявной гарантии ТОВАРНОГО ВИДА
	или ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Подробнее см. в Меньшей Стандартной
	общественной лицензии GNU.

	Вы должны были получить копию Меньшей Стандартной общественной лицензии GNU
	вместе с этой программой. Если это не так, см.
	<https://www.gnu.org/licenses/>.
*/


package javax.microedition.midlet;

import javax.microedition.io.*;
import javax.microedition.lcdui.*;
import malik.emulator.io.j2me.*;

public abstract class MIDlet extends Object
{
	protected MIDlet()
	{
		MIDletProxy.getInstance().registerMIDlet(this);
	}
	
	public final void notifyDestroyed()
	{
		MIDletProxy.getInstance().notifyMIDletDestroyed();
	}

	public final void notifyPaused()
	{
	}
	
	public final void resumeRequest()
	{
	}

	public final boolean platformRequest(String url)
			throws ConnectionNotFoundException
	{
		return ImplementationManager.getConnectionFactory().platformRequest(url);
	}

	public final int checkPermission(String permission)
	{
		return ImplementationManager.getConnectionFactory().checkPermission(permission);
	}

	public final String getAppProperty(String key)
	{
		return MIDletProxy.getInstance().getMIDletDescriptor().get(key);
	}

	protected abstract void startApp()
			throws MIDletStateChangeException;

	protected abstract void pauseApp();

	protected abstract void destroyApp(boolean unconditional)
			throws MIDletStateChangeException;
}
