/*
	Реализация спецификаций CLDC версии 1.1 (JSR-139), MIDP версии 2.1 (JSR-118)
	и других спецификаций для функционирования компактных приложений на языке
	Java (мидлетов) в среде программного обеспечения Малик Эмулятор.

	Copyright © 2016, 2019 Малик Разработчик

	Это свободная программа: вы можете перераспространять ее и/или изменять
	ее на условиях Меньшей Стандартной общественной лицензии GNU в том виде,
	в каком она была опубликована Фондом свободного программного обеспечения;
	либо версии 3 лицензии, либо (по вашему выбору) любой более поздней версии.

	Эта программа распространяется в надежде, что она будет полезной,
	но БЕЗО ВСЯКИХ ГАРАНТИЙ; даже без неявной гарантии ТОВАРНОГО ВИДА
	или ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Подробнее см. в Меньшей Стандартной
	общественной лицензии GNU.

	Вы должны были получить копию Меньшей Стандартной общественной лицензии GNU
	вместе с этой программой. Если это не так, см.
	<https://www.gnu.org/licenses/>.
*/


package malik.emulator.midp.protocol.sms;

import java.util.*;
import javax.wireless.messaging.*;

final class MessageOfBytes extends Object
		implements Message, BinaryMessage
{
	private byte[] passData;
	private String url;

	MessageOfBytes(String url)
	{
		this.url = url;
	}

	MessageOfBytes(String url, byte[] passData)
	{
		this.passData = passData;
		this.url = url;
	}

	public void setAddress(String url)
	{
		this.url = url;
	}

	public String getAddress()
	{
		return url;
	}

	public Date getTimestamp()
	{
		return null;
	}

	public void setPayloadData(byte[] passData)
	{
		this.passData = passData;
	}

	public byte[] getPayloadData()
	{
		return passData;
	}
}
