/*
    Реализация спецификаций CLDC версии 1.1 (JSR-139), MIDP версии 2.1 (JSR-118)
    и других спецификаций для функционирования компактных приложений на языке
    Java (мидлетов) в среде программного обеспечения Малик Эмулятор.

    Copyright © 2016–2017, 2019–2022 Малик Разработчик

    Это свободная программа: вы можете перераспространять ее и/или изменять
    ее на условиях Меньшей Стандартной общественной лицензии GNU в том виде,
    в каком она была опубликована Фондом свободного программного обеспечения;
    либо версии 3 лицензии, либо (по вашему выбору) любой более поздней версии.

    Эта программа распространяется в надежде, что она будет полезной,
    но БЕЗО ВСЯКИХ ГАРАНТИЙ; даже без неявной гарантии ТОВАРНОГО ВИДА
    или ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Подробнее см. в Меньшей Стандартной
    общественной лицензии GNU.

    Вы должны были получить копию Меньшей Стандартной общественной лицензии GNU
    вместе с этой программой. Если это не так, см.
    <https://www.gnu.org/licenses/>.
*/

package java.io;

public interface DataOutput
{
    public void write(int byteData) throws IOException;

    public void write(byte[] src) throws IOException;

    public void write(byte[] src, int offset, int length) throws IOException;

    public void writeBoolean(boolean booleanData) throws IOException;

    public void writeChar(int charData) throws IOException;

    public void writeFloat(float floatData) throws IOException;

    public void writeDouble(double doubleData) throws IOException;

    public void writeByte(int byteData) throws IOException;

    public void writeShort(int shortData) throws IOException;

    public void writeInt(int intData) throws IOException;

    public void writeLong(long longData) throws IOException;

    public void writeChars(String charsData) throws IOException;

    public void writeUTF(String utfData) throws IOException;
}
