/*
    Реализация спецификаций CLDC версии 1.1 (JSR-139), MIDP версии 2.1 (JSR-118)
    и других спецификаций для функционирования компактных приложений на языке
    Java (мидлетов) в среде программного обеспечения Малик Эмулятор.

    Copyright © 2016–2017, 2019–2022 Малик Разработчик

    Это свободная программа: вы можете перераспространять ее и/или изменять
    ее на условиях Меньшей Стандартной общественной лицензии GNU в том виде,
    в каком она была опубликована Фондом свободного программного обеспечения;
    либо версии 3 лицензии, либо (по вашему выбору) любой более поздней версии.

    Эта программа распространяется в надежде, что она будет полезной,
    но БЕЗО ВСЯКИХ ГАРАНТИЙ; даже без неявной гарантии ТОВАРНОГО ВИДА
    или ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Подробнее см. в Меньшей Стандартной
    общественной лицензии GNU.

    Вы должны были получить копию Меньшей Стандартной общественной лицензии GNU
    вместе с этой программой. Если это не так, см.
    <https://www.gnu.org/licenses/>.
*/

package javax.microedition.io;

import java.io.*;

public interface HttpConnection extends ContentConnection
{
    public static final int HTTP_OK                = 200;
    public static final int HTTP_CREATED           = 201;
    public static final int HTTP_ACCEPTED          = 202;
    public static final int HTTP_NOT_AUTHORITATIVE = 203;
    public static final int HTTP_NO_CONTENT        = 204;
    public static final int HTTP_RESET             = 205;
    public static final int HTTP_PARTIAL           = 206;
    public static final int HTTP_MULT_CHOICE       = 300;
    public static final int HTTP_MOVED_PERM        = 301;
    public static final int HTTP_MOVED_TEMP        = 302;
    public static final int HTTP_SEE_OTHER         = 303;
    public static final int HTTP_NOT_MODIFIED      = 304;
    public static final int HTTP_USE_PROXY         = 305;
    public static final int HTTP_TEMP_REDIRECT     = 307;
    public static final int HTTP_BAD_REQUEST       = 400;
    public static final int HTTP_UNAUTHORIZED      = 401;
    public static final int HTTP_PAYMENT_REQUIRED  = 402;
    public static final int HTTP_FORBIDDEN         = 403;
    public static final int HTTP_NOT_FOUND         = 404;
    public static final int HTTP_BAD_METHOD        = 405;
    public static final int HTTP_NOT_ACCEPTABLE    = 406;
    public static final int HTTP_PROXY_AUTH        = 407;
    public static final int HTTP_CLIENT_TIMEOUT    = 408;
    public static final int HTTP_CONFLICT          = 409;
    public static final int HTTP_GONE              = 410;
    public static final int HTTP_LENGTH_REQUIRED   = 411;
    public static final int HTTP_PRECON_FAILED     = 412;
    public static final int HTTP_ENTITY_TOO_LARGE  = 413;
    public static final int HTTP_REQ_TOO_LONG      = 414;
    public static final int HTTP_UNSUPPORTED_TYPE  = 415;
    public static final int HTTP_UNSUPPORTED_RANGE = 416;
    public static final int HTTP_EXPECT_FAILED     = 417;
    public static final int HTTP_INTERNAL_ERROR    = 500;
    public static final int HTTP_NOT_IMPLEMENTED   = 501;
    public static final int HTTP_BAD_GATEWAY       = 502;
    public static final int HTTP_UNAVAILABLE       = 503;
    public static final int HTTP_GATEWAY_TIMEOUT   = 504;
    public static final int HTTP_VERSION           = 505;
    public static final String GET  = "GET";
    public static final String HEAD = "HEAD";
    public static final String POST = "POST";

    public void setRequestMethod(String method) throws IOException;

    public void setRequestProperty(String key, String value) throws IOException;

    public int getPort();

    public int getResponseCode() throws IOException;

    public int getHeaderFieldInt(String fieldName, int defaultInt) throws IOException;

    public long getDate() throws IOException;

    public long getExpiration() throws IOException;

    public long getLastModified() throws IOException;

    public long getHeaderFieldDate(String fieldName, long defaultDate) throws IOException;

    public String getURL();

    public String getRef();

    public String getHost();

    public String getFile();

    public String getQuery();

    public String getProtocol();

    public String getRequestMethod();

    public String getRequestProperty(String key);

    public String getResponseMessage() throws IOException;

    public String getHeaderField(int fieldIndex) throws IOException;

    public String getHeaderField(String fieldName) throws IOException;

    public String getHeaderFieldKey(int fieldIndex) throws IOException;
}
