/*
    Реализация спецификаций CLDC версии 1.1 (JSR-139), MIDP версии 2.1 (JSR-118)
    и других спецификаций для функционирования компактных приложений на языке
    Java (мидлетов) в среде программного обеспечения Малик Эмулятор.

    Copyright © 2016–2017, 2019–2022 Малик Разработчик

    Это свободная программа: вы можете перераспространять ее и/или изменять
    ее на условиях Меньшей Стандартной общественной лицензии GNU в том виде,
    в каком она была опубликована Фондом свободного программного обеспечения;
    либо версии 3 лицензии, либо (по вашему выбору) любой более поздней версии.

    Эта программа распространяется в надежде, что она будет полезной,
    но БЕЗО ВСЯКИХ ГАРАНТИЙ; даже без неявной гарантии ТОВАРНОГО ВИДА
    или ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Подробнее см. в Меньшей Стандартной
    общественной лицензии GNU.

    Вы должны были получить копию Меньшей Стандартной общественной лицензии GNU
    вместе с этой программой. Если это не так, см.
    <https://www.gnu.org/licenses/>.
*/

package javax.microedition.lcdui;

import malik.emulator.application.*;

public abstract class CustomCanvas extends Canvas
{
    protected CustomCanvas() {
    }

    protected CustomCanvas(String title) {
        super(title);
    }

    protected CustomCanvas(String title, Ticker ticker, boolean fullScreen) {
        super(title, ticker, fullScreen);
    }

    protected abstract void paint(Graphics render);

    protected void show() {
        showNotify();
    }

    protected void hide() {
        hideNotify();
    }

    protected void keyboardEvent(KeyboardEvent event) {
        super.keyboardEvent(event);
    }

    protected final void flushBuffer(Image clipBuffer) {
        requestPaintClient(0, 0, getTotalWidth(), getClientHeight(), clipBuffer);
        servicePaint();
    }

    protected final void flushBuffer(int clipLeft, int clipTop, int clipWidth, int clipHeight, Image clipBuffer) {
        requestPaintClient(clipLeft, clipTop, clipWidth, clipHeight, clipBuffer);
        servicePaint();
    }
}
