/*
    Реализация спецификаций CLDC версии 1.1 (JSR-139), MIDP версии 2.1 (JSR-118)
    и других спецификаций для функционирования компактных приложений на языке
    Java (мидлетов) в среде программного обеспечения Малик Эмулятор.

    Copyright © 2016–2017, 2019–2022 Малик Разработчик

    Это свободная программа: вы можете перераспространять ее и/или изменять
    ее на условиях Меньшей Стандартной общественной лицензии GNU в том виде,
    в каком она была опубликована Фондом свободного программного обеспечения;
    либо версии 3 лицензии, либо (по вашему выбору) любой более поздней версии.

    Эта программа распространяется в надежде, что она будет полезной,
    но БЕЗО ВСЯКИХ ГАРАНТИЙ; даже без неявной гарантии ТОВАРНОГО ВИДА
    или ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Подробнее см. в Меньшей Стандартной
    общественной лицензии GNU.

    Вы должны были получить копию Меньшей Стандартной общественной лицензии GNU
    вместе с этой программой. Если это не так, см.
    <https://www.gnu.org/licenses/>.
*/

package malik.emulator.microedition.lcdui;

import malik.emulator.application.*;

public abstract class InputMode extends Object
{
    private final String characterSubset;

    protected InputMode(String characterSubset) {
        this.characterSubset = characterSubset;
    }

    public abstract void keyboardEvent(KeyboardEvent event, CharacterDestination destination);

    public boolean equals(Object anot) {
        String c;
        return anot == this || anot instanceof InputMode && ((c = ((InputMode) anot).characterSubset) == null ? characterSubset == null : c.equals(characterSubset));
    }

    public int hashCode() {
        String c;
        return (c = characterSubset) == null ? 0 : c.hashCode();
    }

    public boolean isCharacterSubset(String characterSubset) {
        String c;
        return (c = this.characterSubset) == null ? characterSubset == null : c.equals(characterSubset);
    }

    public final String getCharacterSubset() {
        return characterSubset;
    }

    public final String getLocalizedName() {
        String c;
        if((c = characterSubset) != null)
        {
            if((c = System.getProperty("input.mode.localized.".concat(c))) != null) return c;
            return System.getProperty("input.mode.localized.INVALID");
        }
        return System.getProperty("input.mode.localized.DEFAULT");
    }
}
