/*
    Реализация спецификаций CLDC версии 1.1 (JSR-139), MIDP версии 2.1 (JSR-118)
    и других спецификаций для функционирования компактных приложений на языке
    Java (мидлетов) в среде программного обеспечения Малик Эмулятор.

    Copyright © 2016–2017, 2019–2022 Малик Разработчик

    Это свободная программа: вы можете перераспространять ее и/или изменять
    ее на условиях Меньшей Стандартной общественной лицензии GNU в том виде,
    в каком она была опубликована Фондом свободного программного обеспечения;
    либо версии 3 лицензии, либо (по вашему выбору) любой более поздней версии.

    Эта программа распространяется в надежде, что она будет полезной,
    но БЕЗО ВСЯКИХ ГАРАНТИЙ; даже без неявной гарантии ТОВАРНОГО ВИДА
    или ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Подробнее см. в Меньшей Стандартной
    общественной лицензии GNU.

    Вы должны были получить копию Меньшей Стандартной общественной лицензии GNU
    вместе с этой программой. Если это не так, см.
    <https://www.gnu.org/licenses/>.
*/

package malik.emulator.microedition.lcdui;

import malik.emulator.application.*;

public class SystemInputMode extends InputMode
{
    public SystemInputMode() {
        super("SYSTEM");
    }

    public void keyboardEvent(KeyboardEvent event, CharacterDestination destination) {
        int charCode;
        switch(event.getAction())
        {
        default:
            break;
        case KeyboardEvent.ACTION_KEY_PRESSED:
        case KeyboardEvent.ACTION_KEY_REPEATED:
            if((charCode = event.getCharCode()) > 0x0000 && charCode <= 0xffff) destination.insert((char) charCode);
            break;
        }
    }

    public boolean isCharacterSubset(String characterSubset) {
        return true;
    }
}
