/*
    Реализация спецификаций CLDC версии 1.1 (JSR-139), MIDP версии 2.1 (JSR-118)
    и других спецификаций для функционирования компактных приложений на языке
    Java (мидлетов) в среде программного обеспечения Малик Эмулятор.

    Copyright © 2016–2017, 2019–2022 Малик Разработчик

    Это свободная программа: вы можете перераспространять ее и/или изменять
    ее на условиях Меньшей Стандартной общественной лицензии GNU в том виде,
    в каком она была опубликована Фондом свободного программного обеспечения;
    либо версии 3 лицензии, либо (по вашему выбору) любой более поздней версии.

    Эта программа распространяется в надежде, что она будет полезной,
    но БЕЗО ВСЯКИХ ГАРАНТИЙ; даже без неявной гарантии ТОВАРНОГО ВИДА
    или ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Подробнее см. в Меньшей Стандартной
    общественной лицензии GNU.

    Вы должны были получить копию Меньшей Стандартной общественной лицензии GNU
    вместе с этой программой. Если это не так, см.
    <https://www.gnu.org/licenses/>.
*/

package javax.obex;

public class ResponseCodes extends Object
{
    public static final int OBEX_HTTP_OK                = 160;
    public static final int OBEX_HTTP_CREATED           = 161;
    public static final int OBEX_HTTP_ACCEPTED          = 162;
    public static final int OBEX_HTTP_NOT_AUTHORITATIVE = 163;
    public static final int OBEX_HTTP_NO_CONTENT        = 164;
    public static final int OBEX_HTTP_RESET             = 165;
    public static final int OBEX_HTTP_PARTIAL           = 166;
    public static final int OBEX_HTTP_MULT_CHOICE       = 176;
    public static final int OBEX_HTTP_MOVED_PERM        = 177;
    public static final int OBEX_HTTP_MOVED_TEMP        = 178;
    public static final int OBEX_HTTP_SEE_OTHER         = 179;
    public static final int OBEX_HTTP_NOT_MODIFIED      = 180;
    public static final int OBEX_HTTP_USE_PROXY         = 181;
    public static final int OBEX_HTTP_BAD_REQUEST       = 192;
    public static final int OBEX_HTTP_UNAUTHORIZED      = 193;
    public static final int OBEX_HTTP_PAYMENT_REQUIRED  = 194;
    public static final int OBEX_HTTP_FORBIDDEN         = 195;
    public static final int OBEX_HTTP_NOT_FOUND         = 196;
    public static final int OBEX_HTTP_BAD_METHOD        = 197;
    public static final int OBEX_HTTP_NOT_ACCEPTABLE    = 198;
    public static final int OBEX_HTTP_PROXY_AUTH        = 199;
    public static final int OBEX_HTTP_TIMEOUT           = 200;
    public static final int OBEX_HTTP_CONFLICT          = 201;
    public static final int OBEX_HTTP_GONE              = 202;
    public static final int OBEX_HTTP_LENGTH_REQUIRED   = 203;
    public static final int OBEX_HTTP_PRECON_FAILED     = 204;
    public static final int OBEX_HTTP_ENTITY_TOO_LARGE  = 205;
    public static final int OBEX_HTTP_REQ_TOO_LARGE     = 206;
    public static final int OBEX_HTTP_UNSUPPORTED_TYPE  = 207;
    public static final int OBEX_HTTP_INTERNAL_ERROR    = 208;
    public static final int OBEX_HTTP_NOT_IMPLEMENTED   = 209;
    public static final int OBEX_HTTP_BAD_GATEWAY       = 210;
    public static final int OBEX_HTTP_UNAVAILABLE       = 211;
    public static final int OBEX_HTTP_GATEWAY_TIMEOUT   = 212;
    public static final int OBEX_HTTP_VERSION           = 213;
    public static final int OBEX_DATABASE_FULL          = 224;
    public static final int OBEX_DATABASE_LOCKED        = 225;

    private ResponseCodes() {
    }
}
